# Uses of Interface
com.sun.mirror.type.TypeMirror

Packages that use TypeMirror
Package
Description
com.sun.mirror.declaration
Interfaces used to model program element declarations.
com.sun.mirror.type
Interfaces used to model types.
com.sun.mirror.util
Utilities to assist in the processing of declarations and types.

## Uses of TypeMirror in com.sun.mirror.declaration

Methods in com.sun.mirror.declaration that return TypeMirror
Modifier and Type
Method
Description
`TypeMirror`
MethodDeclaration.`getReturnType()`
Returns the formal return type of this method.
`TypeMirror`
FieldDeclaration.`getType()`
Returns the type of this field.
`TypeMirror`
ParameterDeclaration.`getType()`
Returns the type of this parameter.

## Uses of TypeMirror in com.sun.mirror.type

Subinterfaces of TypeMirror in com.sun.mirror.type
Modifier and Type
Interface
Description
`interface`
`AnnotationType`
Represents an annotation type.
`interface`
`ArrayType`
Represents an array type.
`interface`
`ClassType`
Represents a class type.
`interface`
`DeclaredType`
Represents a declared type, either a class type or an interface type.
`interface`
`EnumType`
Represents an enum type.
`interface`
`InterfaceType`
Represents an interface type.
`interface`
`PrimitiveType`
Represents a primitive type.
`interface`
`ReferenceType`
Represents a reference type.
`interface`
`TypeVariable`
Represents a type variable.
`interface`
`VoidType`
A pseudo-type representing the type of `void`.
`interface`
`WildcardType`
Represents a wildcard type argument.
Methods in com.sun.mirror.type that return TypeMirror
Modifier and Type
Method
Description
`TypeMirror`
ArrayType.`getComponentType()`
Returns the component type of this array type.
`TypeMirror`
MirroredTypeException.`getTypeMirror()`
Returns the type mirror corresponding to the type being accessed.
Methods in com.sun.mirror.type that return types with arguments of type TypeMirror
Modifier and Type
Method
Description
`Collection<TypeMirror>`
DeclaredType.`getActualTypeArguments()`
Returns (in order) the actual type arguments of this type.
`Collection<TypeMirror>`
MirroredTypesException.`getTypeMirrors()`
Returns the type mirrors corresponding to the types being accessed.
Constructors in com.sun.mirror.type with parameters of type TypeMirror
Modifier
Constructor
Description
``
`MirroredTypeException(TypeMirror type)`
Constructs a new MirroredTypeException for the specified type.
Constructor parameters in com.sun.mirror.type with type arguments of type TypeMirror
Modifier
Constructor
Description
``
`MirroredTypesException(Collection<TypeMirror> types)`
Constructs a new MirroredTypesException for the specified types.

## Uses of TypeMirror in com.sun.mirror.util

Methods in com.sun.mirror.util that return TypeMirror
Modifier and Type
Method
Description
`TypeMirror`
Types.`getErasure(TypeMirror t)`
Returns the erasure of a type.
Methods in com.sun.mirror.util with parameters of type TypeMirror
Modifier and Type
Method
Description
`ArrayType`
Types.`getArrayType(TypeMirror componentType)`
Returns an array type with the specified component type.
`DeclaredType`
Types.`getDeclaredType(TypeDeclaration decl, TypeMirror... typeArgs)`
Returns the type corresponding to a type declaration and actual type arguments.
`DeclaredType`
Types.`getDeclaredType(DeclaredType containing, TypeDeclaration decl, TypeMirror... typeArgs)`
Returns the type corresponding to a type declaration and actual arguments, given a containing type of which it is a member.
`TypeMirror`
Types.`getErasure(TypeMirror t)`
Returns the erasure of a type.
`boolean`
Types.`isAssignable(TypeMirror t1, TypeMirror t2)`
Tests whether one type is assignable to another.
`boolean`
Types.`isSubtype(TypeMirror t1, TypeMirror t2)`
Tests whether one type is a subtype of the another.
`void`
SimpleTypeVisitor.`visitTypeMirror(TypeMirror t)`
Visits a type mirror.
`void`
TypeVisitor.`visitTypeMirror(TypeMirror t)`
Visits a type mirror.